<template>

        
      <b-card no-body >
        <template v-slot:header>
          <h6 class="mb-0">Chat</h6>
        </template>
        <div class="chat">
          <div class="messageContainer">
            <div ref="mCont" class="messages">
              <p>Room {{roomId}}</p>
              <p  v-for="(msg, mIdx) in messages" v-bind:key="mIdx" :class="{'smsg': !msg.user, 'msg': true}">
                <strong v-if="msg.user">{{ msg.user }}:</strong> {{msg.message}}
              </p>
            </div>
          </div>
          <b-input-group>
          <b-form-input v-model="message"  v-on:keyup.enter="sendMessage" placeholder="Introduza a sua mensagem..."></b-form-input>
            <b-input-group-append>
              <b-button  v-on:click="sendMessage" >Enviar</b-button>
            </b-input-group-append>
          </b-input-group>
        </div>
      </b-card>



</template>

<script>

import UserService from '@/services/User'

export default {
  name: 'Chat',
  data () {
    return {
      messages : [],
      message : "",
      user : "",
    }
  },
  sockets : {
    connect: function () {

    },
    history :function (data) {
      this.messages.push({user : data.user , message: data.message});

      this.$nextTick(() => {
        this.$refs.mCont.scrollTop = this.$refs.mCont.scrollHeight;
      })

    },
    chat: function (data) {
      this.messages.push({user : data.user , message: data.message});

      if(this.user != data.user && data.user) {
        this.playBeep();
      }
    
      this.$nextTick(() => {
        this.$refs.mCont.scrollTop = this.$refs.mCont.scrollHeight;
      })
      
    },
    userJoined : function (user) {
      this.messages.push({
        message: `O utilizador ${user} entrou no jogo.`
      })
    }
  },
  props: {
    roomId: String
  },
  async beforeMount() {
    //this.$socket.emit('join', this.roomId);
    this.user = (await UserService.getUser()).username;
  },
  methods : {
    sendMessage() {
      if(this.message.trim().length > 0) {
      this.$socket.emit('chat', this.roomId, this.message);
      this.message  = "";
      }
    },

    playBeep() {
      let beep = new Audio('/sounds/message.wav');
      beep.play();
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>

.messages {
  overflow: auto;
  height: 100%;

}

.messageContainer {
  height: 342px;
  margin-bottom: 5px;

}

.chat {
  padding: 10px;
}

.msg {
   font-family: 'Raleway', sans-serif;
}
.smsg {
  font-weight: bold;

}

</style>
